=== debian/changelog ===
taskcoach (1.4.4-1) unstable; urgency=medium

  * New upstream release.
    Depend on python-igraph.
    Remove new generated files when repackaging.
  * Fix installation path for appdata.xml.
  * Drop obsolete version restrictions in dependencies.
  * Standards-Version: 4.2.1.
  * Rules-Requires-Root: no.
  * Replace more HTTP with HTTPS.
  * Replace more ADTTMP with AUTOPKGTEST_TMP.
  * Remove unused options from watch file.

  [ Ondřej Nový <onovy@debian.org> ]
  * d/tests: Use AUTOPKGTEST_TMP instead of ADTTMP
  * d/watch: Use https protocol

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 15 Dec 2018 14:13:29 +0100

taskcoach (1.4.3-8) unstable; urgency=medium

  * Ignore python-gtk2 if installed. Closes: #897380.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 02 May 2018 19:16:31 +0200

taskcoach (1.4.3-7) unstable; urgency=medium

  * Really disable parallel execution of upstream Makefile under xvfb.
  * Migrate VCS-* to salsa.debian.org.
  * Drop obsolete suggest: python-kde4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Apr 2018 11:15:20 +0200
