=== debian/watch ===
version=4
https://sf.net/taskcoach/TaskCoach@ANY_VERSION@-raw@ARCHIVE_EXT@
