=== debian/changelog ===
taskcoach (1.4.6-1) unstable; urgency=medium

  * New upstream release.
  * Create debian/upstream/metadata.
  * Standards-Version: 4.4.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 08 Jul 2019 11:44:11 +0200

taskcoach (1.4.5-1) experimental; urgency=medium

  * New upstream release.
  * Debhelper 12. Call setup.py directly.
  * Standards-Version: 4.3.0.
  * Update the appdata patch, increase the icon size to 64x64.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 23 Apr 2019 14:55:04 +0200
