=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: utils
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends-Indep: debhelper (>= 11),
+Build-Depends:
+ debhelper-compat (= 12),
 # 2.6.6-3~: https://wiki.debian.org/Python/TransitionToDHPython2
  python,
  dh-python,
@@ -25,7 +26,7 @@
 # See tests/control.
  hicolor-icon-theme, locales-all, x11-utils, xauth, xvfb
 # Also see patches/run_img2py_inside_xvfb.diff.
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Rules-Requires-Root: no
 Homepage: https://www.taskcoach.org
 Vcs-Browser: https://salsa.debian.org/debian/taskcoach
