=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_clean::
# clean and reallyclean cannot run in parallel.
	$(MAKE) reallyclean
override_dh_auto_build:
# img2py needs an X display to convert images.
# Do not mix xvfb-run and parallelism.
	xvfb-run $(MAKE) -j1 prepare
	python setup.py build
override_dh_auto_install::
	python setup.py install --root=debian/taskcoach --install-layout=deb

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	rm -fr tests_tmp
# Disable unit until they migrate to python-wxgtk3.0.
#	AUTOPKGTEST_TMP=. sh debian/tests/unittests
endif
override_dh_auto_clean::
	rm -rf tests_tmp

# Translate upstream changelog to text for dh_installchangelogs.
# Upstream "make clean" will remove it.
CHANGES.txt:
	python changes.in/make.py text > $@
override_dh_auto_build: CHANGES.txt

# Files extracted from thirdparty tarballs by "make prepare" should be
# deleted with "make nuke", but upstream implementation uses the local
# subversion repository so we have to do an ugly explicit list.
# Information about thirdparty is centralized in debian/copyright.
override_dh_auto_clean::
	rm -f -r taskcoachlib/thirdparty/aui
	rm -f    taskcoachlib/thirdparty/customtreectrl.py
	rm -f -r taskcoachlib/thirdparty/desktop
	rm -f -r taskcoachlib/thirdparty/gntp
	rm -f    taskcoachlib/thirdparty/hypertreelist.py
	rm -f -r taskcoachlib/thirdparty/ntlm
	rm -f    taskcoachlib/thirdparty/pybonjour.py
	rm -f    taskcoachlib/thirdparty/wmi.py
	rm -f -r taskcoachlib/thirdparty/wxScheduler

# Generated file, see Files-Excluded stanza in copyright file.
override_dh_auto_clean::
	rm -f i18n.in/messages.pot

# Provide an icon for the menu file.
XPM_ICON := icons.in/taskcoach.xpm
$(XPM_ICON): %.xpm: %.png
	gm convert -resize 64x64 $< $@
override_dh_auto_build: $(XPM_ICON)
override_dh_auto_install::
	dh_install $(XPM_ICON) usr/share/pixmaps
override_dh_auto_clean::
	rm -f $(XPM_ICON)

# Upstream provides the main executable with a .py suffix.
EXE_DIR := debian/taskcoach/usr/bin
DESKTOP := debian/taskcoach/usr/share/applications/taskcoach.desktop
APPDATA := debian/taskcoach/usr/share/metainfo/taskcoach.appdata.xml
override_dh_auto_install::
	cd $(EXE_DIR) && mv taskcoach.py taskcoach
	sed --in-place 's/Exec=taskcoach\.py/Exec=taskcoach/' $(DESKTOP)
	sed --in-place 's/<binary>taskcoach\.py/<binary>taskcoach/' $(APPDATA)

# Avoid compressing the TODO list, provided in the taskcoach format.
override_dh_compress:
	dh_compress -Xusr/share/doc/taskcoach/TODO.tsk
